# README

This README would normally document whatever steps are necessary to get the
application up and running.

Things you may want to cover:

* Ruby version

* System dependencies

* Configuration

* Database creation

* Database initialization

* How to run the test suite

* Services (job queues, cache servers, search engines, etc.)

* Deployment instructions

* ...

Endpoints

Jobs:

GET  `/current_user`    => current user
GET  `/users`           => list all users
GET  `/teams`           => list all teams
GET  `/teams/:id/users` => all users that can access a team

POST `/jobs`            => create an untracked job
GET  `/jobs/pop`        => pop a job from the queue
PUT  `/jobs/:id/status` => update a job's status

POST `/events`          => enqueue an event for processing

GET  `projects`        => retrieve a list of all projects. by team, by user or all
GET  `projects/:id`    => get a single project
DEL  `projects/:id`    => delete a project
PUT  `projects/:id`    => update a project
POST `projects`        => create a freestyle project
GET  `projects/:id/branches` => retrieve a list of branches with a build status for a project, show all branches option
GET  `projects/:id/jobs`     => retrieve a list of the latest jobs for a project

GET  `/pipelines`                       => list all pipeline definitions by registry with latest status.
GET  `/pipelines/:name/instances`       => list all pipeline instances for this definition
GET  `/pipelines/:name/instances/:id`   => get a specific pipeline, more information, status and jobs

GET  `/libraries`       => list all installed libraries known
POST `/libraries`       => install a library
DEL  `/libraries/:name` => uninstall a library
